//
//  ViewController.swift
//  image
//
//  Created by kunii on 2017/07/13.
//  Copyright © 2017年 aiois. All rights reserved.
//

import UIKit
import AVFoundation

class ViewController: UIViewController {
    
    var imageView:UIImageView!      //  人物用
    var message:UILabel!            //  セリフ・説明用

    //  セリフ・説明
    let script : [ [String:Any] ]  = [
        ["主体" : "主人公","行動" : "喋る","対象" : "雨の日はだるい…"],
        ["主体" : "主人公","行動" : "喋る","対象" : "今日は学校休んじゃおっかな〜"],
        ["主体" : "主人公","行動" : "喋る","対象" : "誰だ"],
        ["主体" : "前景","行動" : "フェードイン","対象" : "girl"],
        ["主体" : "主人公","行動" : "喋る","対象" : "「須瀬」？"],
        ["主体" : "主人公","行動" : "喋る","対象" : "なんだ、お前も寝坊か？"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "何をのんきな・・・"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "あんたらしいけど"],
        ["主体" : "主人公","行動" : "喋る","対象" : "何が？"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "何でもない"],
        ["主体" : "主人公","行動" : "喋る","対象" : "？"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "まあ、どのみち、もう意味ないしね"],
        ["主体" : "主人公","行動" : "喋る","対象" : "？"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "そうだ。あんた最近、平坂のおじさんと話した？"],
        ["主体" : "主人公","行動" : "喋る","対象" : "いや、でも何で平坂のおじさん？"],
        ["主体" : "須瀬","行動" : "喋る","対象" : "別に、話してないならいい"],
        ["主体" : "前景","行動" : "フェードアウト"],
        ["主体" : "主人公","行動" : "喋る","対象" : "なんだあいつ。急に平坂のおじさんとか"],
        ["主体" : "主人公","行動" : "喋る","対象" : "なんだか学校行く気なくなっちまったな…"],
        ["主体" : "主人公","行動" : "喋る","対象" : "帰るか"],
        ["グループ": [
            ["主体" : "背景","行動" : "フェードアウト"],
            ["主体" : "BGM","行動" : "プレイ","対象" : "traffic.mp3"],
            ["主体" : "主人公","行動" : "喋る","対象" : "歩きながら、半年前のことを思い出していた"]
        ]],
        ["主体" : "主人公","行動" : "喋る","対象" : "嫌な思い出"],
        ["主体" : "主人公","行動" : "喋る","対象" : "幼馴染だった女の子が死んだ日"],
        ["主体" : "主人公","行動" : "喋る","対象" : "平坂なみの葬式で、須瀬は泣いていた"],
        ["主体" : "主人公","行動" : "喋る","対象" : "あの日以来、おじさんとは話してない"],
        ["グループ" : [
            ["主体" : "BGM","行動" : "ストップ"],
            ["主体" : "主人公","行動" : "喋る","対象" : "須瀬がクラスの中で浮き始めたのも、あの日からだったな"]
        ]],
        ["主体" : "主人公","行動" : "喋る","対象" : "平坂、お前がいなくなって須瀬がグレちゃったよ"],
        ["グループ" : [
            ["主体" : "主人公","行動" : "喋る","対象" : "玄関前には、死んだはずの平坂なぎが立っていた"],
            ["主体" : "背景","行動" : "フェードイン", "対象":"entry"],
            ["主体" : "前景","行動" : "フェードイン", "対象":"girl-2"]
        ]]
    ]
    var scriptIndex = 0             //  現在の場面の段階
    var backgroundImageView:UIImageView!    //  背景
    var bgmPlayer:AVAudioPlayer?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        //  背景
        let backgroundImageView = UIImageView(frame:self.view.bounds)
        backgroundImageView.autoresizingMask = [UIViewAutoresizing.flexibleWidth, UIViewAutoresizing.flexibleHeight]
        backgroundImageView.contentMode = UIViewContentMode.scaleAspectFill
        backgroundImageView.image = UIImage(named: "fog-1")
        self.view.addSubview(backgroundImageView)
        
        //  セリフ付き前景
        let baseView = UIView(frame: self.view.bounds.insetBy(dx: 10, dy: 10))
        baseView.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        //  タップに反応するようにする
        baseView.addGestureRecognizer(UITapGestureRecognizer(target: self, action: #selector(tap)))
        self.view.addSubview(baseView)

        //  人物部分
        var frame = baseView.bounds
        frame.size.width *= 0.5
        frame.size.height *= 0.6
        frame.origin.y += baseView.bounds.size.height - frame.size.height
        let imageView = UIImageView(frame:frame.insetBy(dx: 0, dy: 20))
        imageView.contentMode = UIViewContentMode.scaleAspectFill
        imageView.image = UIImage(named: "girl")
        imageView.alpha = 0
        baseView.addSubview(imageView)

        //  セリフ部分（すりガラス）
        frame = baseView.bounds
        frame.size.height *= 0.3
        frame.origin.y += baseView.bounds.size.height - frame.size.height
        let back = UIVisualEffectView(frame:frame.insetBy(dx: 20, dy: 20))
        back.layer.cornerRadius = 16
        back.layer.masksToBounds = true
        back.effect = UIBlurEffect(style: UIBlurEffectStyle.light)
        back.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        baseView.addSubview(back)

        //  セリフ部分（文字）
        let message = UILabel(frame:frame.insetBy(dx: 30, dy: 30))
        message.font = UIFont.preferredFont(forTextStyle:UIFontTextStyle.body)
        message.numberOfLines = 5
        message.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        baseView.addSubview(message)

        //  「次へ」インジケータ
        let nextImageView = UIImageView(image:UIImage(named:"next"))
        nextImageView.center = CGPoint(x:back.frame.maxX , y:back.frame.midY)
        nextImageView.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleLeftMargin]
        baseView.addSubview(nextImageView)
        
        //  プロパティとして登録
        self.imageView = imageView
        self.message = message
        self.backgroundImageView = backgroundImageView
        //  スタート
        tap()
    }

    //  場面の段階を1つ進め、それに合わせ、セリフや状況を更新する。
    func tap() {
        if scriptIndex < script.count {
            execute(action:script[scriptIndex])
            scriptIndex += 1
        }
    }
    
    //  action:で渡された辞書に従ってセリフや状況を更新する。
    func execute(action: [String : Any]) {
        //  "グループ"キーワードを持つなら、複数の処理を配列で持っている
        if let actions = action["グループ"] as? [ [String : Any] ] {
            //  配列内のすべての要素を実行
            for action in actions {
                execute(action:action)
            }
            return
        }
        //  "主体"、"行動"、"対象"要素を取り出す。"対象"以外は必須。
        guard let subject = action["主体"] as? String,
            let operation = action["行動"] as? String else {
                //  作業継続不可能なので戻る
                return
        }
        let target = action["対象"] as? String
        
        //  "主体"別に処理を実行
        switch subject {
        case "主人公", "須瀬":
            person(subject:subject, operation:operation, target:target)
        case "前景" ,"背景":
            view(subject:subject, operation:operation, target:target)
        case "BGM":
            bgm(subject:subject, operation:operation, target:target)
        default:break
        }
    }
    
    //  "主人公", "須瀬"等、人間用
    func person(subject:String, operation:String, target:String?) {
        if operation == "喋る" {
            self.message.textColor = subject == "主人公" ? UIColor.black : UIColor.purple
            if let text = target {
                self.message.text = text
            }
        }
    }
    
    //  "前景" ,"背景"等、画面用
    func view(subject:String, operation:String, target:String?) {
        let iview = (subject == "前景") ? self.imageView : self.backgroundImageView
        switch operation {
        case "フェードイン", "フェードアウト":
            if let imageName = target {
                //  画像指定があるなら設定する
                iview?.image = UIImage(named:imageName)
            }
            UIView.animate(withDuration: 2, animations: {
                iview?.alpha = operation == "フェードイン" ? 1 : 0
            })
        default:break
        }
    }
    
    //  BGM用
    func bgm(subject:String, operation:String, target:String?) {
        if operation == "ストップ" {
            //  停止
            bgmPlayer?.stop()
            return
        }
        if operation == "プレイ" {
            //  再生　target指定された音ファイルを再生する
            guard let soundName = target else {
                return
            }
            guard let url = Bundle.main.url(forResource: soundName, withExtension: nil) else {
                return
            }
            //  AVAudioPlayerは毎回作成する
            bgmPlayer = try? AVAudioPlayer(contentsOf: url)
            bgmPlayer?.play()
        }
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

}

